#import <React/RCTBridgeModule.h>
#import <React/RCTEventEmitter.h>

@interface RCT_EXTERN_MODULE(NativeAudioEngine, RCTEventEmitter)

//RCT_EXTERN_METHOD(multiply:(float)a withB:(float)b
//                 withResolver:(RCTPromiseResolveBlock)resolve
//                 withRejecter:(RCTPromiseRejectBlock)reject)

//RCT_EXTERN_METHOD(setOnFinishPlaying:(RCTResponseSenderBlock)onFinishPlaying)
//RCT_EXTERN_METHOD(setOnTimeChange:(RCTResponseSenderBlock)onTimeChange)
//RCT_EXTERN_METHOD(setAudioFrequencyListener:(RCTResponseSenderBlock)audioFrequencyListener)

RCT_EXTERN_METHOD(setExternalAudio:(NSString *)path)
RCT_EXTERN_METHOD(startRecording)
RCT_EXTERN_METHOD(finishRecording)
RCT_EXTERN_METHOD(playAudio)
RCT_EXTERN_METHOD(stopPlaying)

RCT_EXTERN_METHOD(pause)
RCT_EXTERN_METHOD(resume)

RCT_EXTERN_METHOD(setExternalAudioVolume:(float)v)
RCT_EXTERN_METHOD(setMicVolume:(float)v)
RCT_EXTERN_METHOD(setTrackVolume:(float)v)
RCT_EXTERN_METHOD(selectTrack:(Int)trackIndex)
RCT_EXTERN_METHOD(seekPlayer:(double)s)
RCT_EXTERN_METHOD(addTrack)
RCT_EXTERN_METHOD(removeTrack:(Int)at)
RCT_EXTERN_METHOD(createWaveformSginalPositive:(NSString *)audioFile
                  (RCTPromiseResolveBlock)resolve
                  (RCTPromiseRejectBlock) reject
                  )
RCT_EXTERN_METHOD(createWaveformSginal:(NSString *)audioFile (RCTPromiseResolveBlock)resolve (RCTPromiseRejectBlock)reject)

RCT_EXTERN_METHOD(setFeedback:(Int)value) // -100...100
RCT_EXTERN_METHOD(setDelayDryWetMix:(float)value)  //0...100
RCT_EXTERN_METHOD(setDelayTime:(double)sec)  //0...2
RCT_EXTERN_METHOD(addDelay)

RCT_EXTERN_METHOD(setAutoTunePitch:(float)) // -2400...2400 cent
RCT_EXTERN_METHOD(addAutoTune)

RCT_EXTERN_METHOD(setEQBandgain:(Int)bandIndex (float)decible) // bandIndex : 0,1,2 + Decible : -12 ... 12
RCT_EXTERN_METHOD(addEQ)

RCT_EXTERN_METHOD(toggleReverb)
RCT_EXTERN_METHOD(setReverbDryWetMix:(float)value) //0...100
RCT_EXTERN_METHOD(setReverbPreset:(Int)index) //0,1,2

RCT_EXTERN_METHOD(exportFile:(RCTPromiseResolveBlock)resolve rejecter:(RCTPromiseRejectBlock)reject)

+ (BOOL)requiresMainQueueSetup
{
  return NO;
}

@end
